<html lang="en" class="+full-height"><head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

        <!-- Kwaeri CSS -->
        <link rel="stylesheet" href="https://mmod.gitlab.io/kwaeri-user-experience/dist/css/kux_md--comprehensive.min.css">

        <title>@kwaeri/migration</title>
    </head>
    <body class="+inverse-colors mdc-typography">

        <!-- The Side Menu - MDC Drawer Based. We add a bit of functionality to provide a feature rich Side Menu. -->
        <aside data-menu="side-menu" data-menu-type="hybrid-permanent-modal" data-menu-initialized="false" class="mdc-drawer side-menu +mimic-appbar +inverse ">
            <div class="mdc-drawer__toolbar-spacer"></div>
            <header class="mdc-drawer__header">
                <div class="mdc-drawer__header-content">
                  <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=YUW4CWCAABCU2" target="_blank" title="Donate to Massivley Modified" class="image-link +horizontally-centered"><div class="icon-donations"></div></a>
                </div>
            </header>
            <div class="mdc-drawer__content">

                <!-- The Side Menu nav element -->
                <nav id="icon-with-text-demo" class="mdc-list">
                    <!-- Side Menu Section Title -->
                    <span class="side-menu_section-title">Introduction</span>
                    <!-- Side Menu Section Nav -->
                    <ul class="side-menu_nav side-menu_menu-section">

                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="what-is-it" data-scroll-to-target="what-is-it">@kwaeri/mysql-migrator?</button>
                        </li>

                        <!-- Side Menu Section Menu Item -->
                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="getting-started" data-expandable="getting-started" data-expandable-type="side-menu" aria-expanded="false">Getting Started</button>
                            <!-- Side Menu Section Menu Item Sub-Nav (otional) -->
                            <div class="side-menu_submenu-wrap">
                                <!-- Side Menu Sub Nav -->
                                <ul class="submenu_nav submenu_menu-section" data-expand="getting-started" data-expanded="false">
                                    <!-- And there we may place sub-nav_item for each fragment of the section -->
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="prerequisites" data-scroll-to-target="prerequisites">Prerequisites</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="installing-the-module" data-scroll-to-target="installing-the-module">Installing the Module</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="including-the-library" data-scroll-to-target="including-the-library">Including the Library</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="a-complete-example" data-scroll-to-target="a-complete-example">A Complete Example</a></li>
                                </ul>
                            </div>
                        </li>
                    </ul>

                    <!-- Side Menu Section Title -->
                    <span class="side-menu_section-title">Components</span>
                    <!-- Side Menu Section Nav -->
                    <ul class="side-menu_nav side-menu_menu-section">
                        <!-- Side Menu Section Menu Item -->
                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="API " data-expandable="api" data-expandable-type="side-menu" aria-expanded="false">API</button>
                            <!-- Side Menu Section Menu Item Sub-Nav (otional) -->
                            <div class="side-menu_submenu-wrap">
                                <!-- Side Menu Sub Nav -->
                                <ul class="submenu_nav submenu_menu-section" data-expand="api" data-expanded="false">

                                    <!-- And there we may place sub-nav_item for each fragment of the section -->
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="checkInstall" data-scroll-to-target="checkInstall">checkInstall()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="install" data-scroll-to-target="install">install()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="migrate" data-scroll-to-target="migrate">migrate()</a></li>
                                </ul>
                            </div>
                        </li>
                    </ul>


                    <div class="side-menu-select-item-divider mdc-list-divider" role="separator"></div>

                    <a class="mdc-list-item" href="mailto:support@mmod.co">
                        <i class="material-icons mdc-list-item__graphic" title="Email Support" aria-hidden="true">email</i>Email Support
                    </a>
                </nav>
            </div>
        </aside> <!-- End the Side Menu-->

        <div class="mdc-drawer-scrim"></div>

        <!-- The topAppBar - we only add a couple things to give additional functionality from what Google gives us. -->
        <header class="mdc-top-app-bar mdc-top-app-bar--fixed" data-animation="rebound-scroll" data-rebounded="false" data-menu="top-menu">
            <div class="mdc-top-app-bar__row">
                <section class="mdc-top-app-bar__section mdc-top-app-bar__section--align-start">
                    <a data-menu="navigation-drawer" data-drawer="permanent" class="material-icons mdc-top-app-bar__navigation-icon hidden">menu</a>
                    <div class="navbar_brand icon-logo-badge-small-dev"></div>
                    <span class="mdc-top-app-bar__title">kwaeri.io</span>
                </section>
                <section class="mdc-top-app-bar__section mdc-top-app-bar__section--align-end" role="toolbar">
                    <div class="mdc-menu-surface--anchor">
                        <a class="material-icons mdc-top-app-bar__action-item" data-dropdown="filedownload" title="Download @kwaeri/configuration" aria-label="Download" alt="Download">file_download</a>
                        <div class="mdc-menu mdc-menu-surface" tabindex="-1" data-menu="dropdown" data-for="filedownload">
                            <ul class="mdc-menu__items mdc-list" role="menu" aria-hidden="true">
                                <li class="mdc-list-item" role="menuitem" tabindex="0">
                                    <a href="https://gitlab.com/kwaeri/cli/providers/mysql-migrator/-/archive/master/configuration-master.zip" class="drop-down_item" title="Download .zip" aria-label="Download .zip">Download a Zip</a>
                                </li>
                                <li class="mdc-list-item" role="menuitem" tabindex="0">
                                    <a href="https://gitlab.com/kwaeri/cli/providers/mysql-migrator/-/archive/master/configuration-master.tar.gz" class="drop-down_item" title="Download .tar.gz" aria-label="Download .tar.gz">Download a Tarball</a>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <a href="/coverage" class="material-icons mdc-top-app-bar__action-item" title="Code Coverage" aria-label="Code Coverage" alt="Code Coverage">book</a>
                </section>
            </div>
        </header> <!-- End the topAppBar -->

        <!-- The Site/App main content -->
        <div id=client-display" data-feature="focus" class="container mdc-top-app-bar--fixed-adjust +flex-side-menu +flex-scrollspy">

            <div class="container-fluid +top">

                <section class="featured +read-easy">

                    <article class="featured_article">


                        <!---<div data-drag="test-handle" class="draggable">
                            <div data-handle="test-handle" class="draggable_handle">Draggable Window: Handle</div>
                            <div class="draggable_content">
                                <p>This is a draggable element.</p>
                            </div>

                        </div>-->


                        <div class="article_header">

                            <div class="article_header+wider">
                                <h1>@kwaeri/mysql-migrator</h1>
                                <p>The @kwaeri/mysql-migrator component of the @kwaeri/user-executable framework.</p>
                            </div>

                            <div class="article_header+related">

                                <span class="content_related-list+title">Contents</span>
                                <ul class="content_related-list">
                                    <li>Related content I</li>
                                    <li>Related content II</li>
                                    <li>Related content III</li>
                                </ul>
                            </div>

                        </div>

                        <hr>

                        <div id="what-is-it" class="article_header+sub">
                            <h6>@kwaeri/migration reinvents and modernizes the migration portion of the node-kit application platform.</h6>

                            <p>The @kwaeri/migration component simplifies working with migrations by standardizing the implementation so that end users may [mostly] seamlessly add, apply, and/or revert migrations within their projects.</p>
                        </div>

                        <hr>

                        <div class="article_body">

                            <!-- A section for Getting Started -->
                            <section id="getting-started" class="article_section"> <!-- Can have a max-width (controlled by media queries) set, but we already do that on featured + read-easy in this example  -->

                                <!-- Section Header -->
                                <h2 class="article_chapter-title">Getting Started</h2>
                                <!-- End of Section Header -->

                                <!-- Section Body -->
                                <div class="section_body"> <!-- Material.io's equivalent, article__copy, only has postiion relative set.. we can do this too! -->


                                    <!-- Section Body Fragment (there should be many ) -->
                                    <div id="prerequisites" class="fragment +collapsible" data-collapsible="prerequisites" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="prerequisites" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Preparing for Installation</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="prerequisites">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="prerequisites">

                                                <p>This section covers the prerequisites for making use of the @kwaeri/migration component.</p>

                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="prerequisites">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
#### Preparing for use

To make use of the @kwaeri/migration component,  you'll need to ensure you meet some prerequisites. The following technologies are required in order to use @kwaeri/migration:

* Node.js (latest version)
    * NPM (typically bundled with later Node.js installs)

The above prerequisites ensure that you are able to install - and make use of - the @kwaeri/migration component.

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->


                                    <!-- Anothe Section Body Fragment -->
                                    <div id="installing-the-module" class="fragment +collapsible" data-collapsible="installing-the-module" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="installing-the-module" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Installing the Module</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="installing-the-module">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="installing-the-module">
                                                <p>This section provides step-by-step instructions for installing @kwaeri/migration.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="installing-the-module">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
#### Installing @kwaeri/migration

To install @kwaeri/migration, please run the following commands from terminal/command-prompt:

<!-- Show a code snippet -->
<pre class="command-line language-bash" data-user="rik" data-host="kwaeri" data-filter-output="[out]">
    <code class="language-bash">
    [out] ...
    npm install @kwaeri/migration
    </code>
</pre><!-- End of code snippet-->

That's it! You're set to make use of the @kwaeri/migration component.

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->

                                    </div> <!-- End of Fragment -->


                                    <!-- Yet Another Section Fragment-->
                                    <div id="including-the-library" class="fragment +collapsible" data-collapsible="including-the-library" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="including-the-library" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Including the Library</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="including-the-library">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="including-the-library">
                                                <p>This section provides instructions for how to include the @kwaeri/migration component within an application.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="including-the-library">

                                                    <!-- A markdown block for providing content to this fragment -->
                                                    <div data-markdown="render" data-rendered="false">
To include @kwaeri/migration in your application, add the following code to the source code you wish to make use of it in:

<!-- Show a code snippet -->
```javascript
import { Migration } from "@kwaeri/migration";
```

That's it! You're set to make use of the @kwaeri/migration component.

                                                    </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->


                                    <!-- Yet Another Section Fragment-->
                                    <div id="a-complete-example" class="fragment +collapsible" data-collapsible="a-complete-example" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="a-complete-example" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Create a migration</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="a-complete-example">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="a-complete-example">
                                                <p>This section provides instructions for how to create a migration using the @kwaeri/migration component.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="a-complete-example">

                                                    <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
In order to run a migration, all that's required is that you create a  migration file and call the migrator's `migrate` method:.

#### Instantiate a Migration

```typescript
// Create a new migration object:
let migrator = new Migration();
...
```

Now we're ready to use the migration system! Let's go over integrating it into your development environment.

#### A Complete Example
...(to be disclosed)

A good way to see how to integrate the @kwaeri/migration migrations system with your development environment (and make use of it outside of `@kwaeri/node-kit`), would be to browse the `node-kit/core/nkm`, `node-kit/core/steward`, and `node-kit/core/generators/migration` files within the `@kwaeri/node-kit` package. Doing this will provide the best example possible - not only for how to create a migration file that's consumable by the migration system, but - for how to integrate the migration system with your development environment, and automate its usage.
                                                    </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                </div> <!-- End of Section Body -->

                            </section> <!-- End of Section -->

                            <hr>

                            <!-- Another Section that moves on to Layout of an application using this Library -->
                            <section id="api" class="article_section">

                                <!-- Section Heading -->
                                <h2 class="article_chapter-title">API</h2>
                                <!-- End of Section Heading -->

                                <!-- Section Body -->
                                <div class="section_body">

                                    <!-- Section Body Fragment -->
                                    <div id="checkInstall" class="fragment +collapsible" data-collapsible="checkInstall" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="checkInstall" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.checkInstall()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="checkInstall">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="checkInstall">
                                                <p>This section provides instructions for making use of the .checkInstall() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="checkInstall">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
The `.checkInstall()` method checks that the migration system is properly installed in a development environment.

#### Example Usage:
```javascript
// check a migration:system install
let migrationsInstalled = await migrator.checkInstall();

if( !migrationsInstalled || !migrationsInstalled.result )
{
    return Promise.reject( new Error( ... ) );
}
...
```

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="install" class="fragment +collapsible" data-collapsible="install" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="install" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.install()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="install">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="install">
                                                <p>This section provides instructions for making use of the .install() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="install">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
The `.install()` method attempts to install the migration system.

#### Example Usage:
```javascript
// installs the migration system
let migrationSystemInstalled = await migrator.install();

if( !migrationSystemInstalled || !migrationSystemInstalled.result )
{
    return Promise.reject( new Error( ... ) );
}
...
```

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="migrate" class="fragment +collapsible" data-collapsible="migrate" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="migrate" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.migrate()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="migrate">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="migrate">
                                                <p>This section provides instructions for making use of the .migrate() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="migrate">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
The `.migrate()` method attempts to process [a] migration(s).

#### Example Usage:
```javascript
// migrate:
let migrated = await migrator.migrate( options );

if( !migrated || !migrated.result )
{
    return Promise.reject( new Error( ... ) );
}
...
```

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                </div> <!-- End of Section Body -->

                            </section> <!-- End of Section -->

                        </div> <!-- End of Article Body -->


                    </article> <!-- End of Article Container -->

                </section> <!-- End of Featured Container -->

            </div> <!-- End of Container-Fluid -->

        </div> <!-- End of Focus Container -->

        <!-- Optional right column, for related, scroll-spy, or advertisement perhaps?
        <nav class="short-nav +scrollspy">
            <div class="short-nav_toolbar-spacer"></div>
            <p>Testing 1,2,3</p>
        </nav>-->

        <button class="mdc-fab material-icons app-fab--absolute" aria-label="Scroll To Top" data-scroll-to-target="top">
            <span class="mdc-fab__icon">
                keyboard_arrow_up
            </span>
        </button>

        <!-- Add JavaScript inclusions just before the closing body tag -->
        <script src="assets/js/prism.js" async></script>
        <script src="https://mmod.gitlab.io/kwaeri-user-experience/dist/js/kwaeri-ux/kux-md-bundle.min.js"></script>

    </body>
</html>